#include "wihu.h"
#include "resource.h"

LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam,LPARAM lParam) {
	int wmId, wmEvent;
	HKEY hKey;
	WCHAR ComputerName[16];
	WCHAR OwnerName[100];
	WCHAR *WkgName;
	DWORD SzComputerName, cbData;
	HMENU hSysMenu;
	DWORD Result;
	NETSETUP_JOIN_STATUS JoinStatus;

	switch (uMsg) {
		case WM_INITDIALOG:
#if 0			
			/* Schlieen Schaltflche (X) deaktivieren */
			hSysMenu = GetSystemMenu(hWnd, FALSE);
			RemoveMenu(hSysMenu, SC_CLOSE, MF_BYCOMMAND);
			
			/* "Abbrechen" Schaltflche deaktivieren */
			EnableWindow(GetDlgItem(hWnd, IDCANCEL), FALSE);
#endif
			/* Eingabelngenbeschrnkung */
			SendMessage(GetDlgItem(hWnd, IDC_EDIT_COMPUTER), EM_LIMITTEXT, 15, 0);
			SendMessage(GetDlgItem(hWnd, IDC_EDIT_OWNER), EM_LIMITTEXT, 100, 0);
			SendMessage(GetDlgItem(hWnd, IDC_EDIT_WKG), EM_LIMITTEXT, 15, 0);

			/* aktuellen Werte ermitteln */
			SzComputerName = sizeof(ComputerName) / sizeof(WCHAR);
			GetComputerName(ComputerName, &SzComputerName);
			SetDlgItemText(hWnd, IDC_EDIT_COMPUTER, ComputerName);

			if (RegOpenKey(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion", &hKey) == 0) {
				cbData = sizeof(OwnerName);
				RegQueryValueEx(hKey, L"RegisteredOwner", NULL, NULL, (LPBYTE) OwnerName, &cbData);
				SetDlgItemText(hWnd, IDC_EDIT_OWNER, OwnerName);
				RegCloseKey(hKey);
			}

			/* "Fertigstellen" Schaltflche deaktivieren wenn Computername leer ist */
			if (GetDlgItemText(hWnd, IDC_EDIT_COMPUTER, ComputerName, sizeof(ComputerName) / sizeof(WCHAR))) {
				EnableWindow(GetDlgItem(hWnd, IDOK), TRUE);
			} else {
				EnableWindow(GetDlgItem(hWnd, IDOK), FALSE);
			}
			
			WkgName = NULL;
			NetGetJoinInformation(NULL, &WkgName, &JoinStatus);
			if (WkgName) {
				SetDlgItemText(hWnd, IDC_EDIT_WKG, WkgName);
				NetApiBufferFree(WkgName);
			}
			/* hier weitere Initialisierungen hinzufgen */

			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			switch (wmId) {
				case IDOK:
					
					/* hier werden die Einstellungen bernommen */
					GetDlgItemText(hWnd, IDC_EDIT_COMPUTER, ComputerName, sizeof(ComputerName) / sizeof(WCHAR));
					GetDlgItemText(hWnd, IDC_EDIT_OWNER, OwnerName, sizeof(OwnerName) / sizeof(WCHAR));

					SetComputerName(ComputerName);

					if (RegOpenKey(HKEY_LOCAL_MACHINE, L"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters", &hKey) == ERROR_SUCCESS) {
						RegSetValueEx(hKey, L"NV Hostname", 0, REG_SZ, (LPBYTE) ComputerName , ((DWORD) wcslen(ComputerName) + 1) * sizeof(WCHAR));
						RegCloseKey(hKey);
					}

					if (RegOpenKey(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion", &hKey) == 0) {
						RegSetValueEx(hKey, L"RegisteredOwner", 0, REG_SZ, (LPBYTE) OwnerName, ((DWORD) wcslen(OwnerName) + 1) * sizeof(WCHAR));
						RegCloseKey(hKey);
					}
					
					/* dyn. Speicher anfordern und Arbeitsgruppenname ermitteln */
					WkgName = LocalAlloc(LPTR, 16 * sizeof(WCHAR));
					GetDlgItemText(hWnd, IDC_EDIT_WKG, WkgName, 15);
					
					/* zu einer Arbeitsgruppe hinzufgen */
					Result = NetJoinDomain(NULL, WkgName, NULL, NULL, NULL, NETSETUP_DOMAIN_JOIN_IF_JOINED);
					switch (Result) {
						case NERR_SetupAlreadyJoined:
							MessageBox(hWnd, L"Already joined", 0, MB_ICONERROR);
							break;
						case NERR_InvalidWorkgroupName:
							MessageBox(hWnd, L"Invalid Workgroup Name", 0, MB_ICONERROR);
							break;
					}
					LocalFree(WkgName);
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_EDIT_COMPUTER:
					if (GetDlgItemText(hWnd, IDC_EDIT_COMPUTER, ComputerName, sizeof(ComputerName) / sizeof(WCHAR))) {
						EnableWindow(GetDlgItem(hWnd, IDOK), TRUE);
					} else {
						EnableWindow(GetDlgItem(hWnd, IDOK), FALSE);
					}
					break;
				default:
					break;
			}
			break;
		case WM_CTLCOLORSTATIC:
			/* Header Steuerelement wei einfrben */
			if ((HWND) lParam == GetDlgItem(hWnd, IDC_HDR) || (HWND) lParam == GetDlgItem(hWnd, IDC_LBL_HDR)) {
				return (LRESULT) GetSysColorBrush(COLOR_WINDOW);
			}
			break;
		case WM_CLOSE:
			EndDialog(hWnd, IDCANCEL);
			break;
		default:
			break;
	}
	return 0;
}

int __stdcall wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nCmdShow) {
	return (int) DialogBox(hInstance, MAKEINTRESOURCE(IDD_DLG_MAIN), GetDesktopWindow(), (DLGPROC) WindowProc);
}
